void setup () 
{  
  frameRate(5);

  // Sketch einstellen
  size (640, 480);
  stroke (255);

  background (200);
}

// plane
float speed = 10.0;
int oldx = 20;
int oldy = 20;
float actdir = 0.0;
float dirtohome;
float disttohome;

//home
int homex = 400;
int homey = 240;

//circle
float circleradius = 80.0;
float offsetangle = 0.0;

boolean tangential = true;
//boolean tangential = false;

void draw () 
{
  int newx, newy;
  float dirrad, dirdiff, ratio;
  int dx, dy;

  dx = homex - oldx;
  dy = homey - oldy;
  dirtohome = 57.29 * atan2(dx, dy);
  disttohome = sqrt(dx*dx + dy*dy);

  if (tangential && (disttohome > 1.0)) {
    ratio = circleradius / disttohome;
    if (ratio >= 1.0) ratio = 1.0; 
    offsetangle = 57.29 * asin(ratio);
  } else { 
    offsetangle = 0.0; 
  }
  
    //print(dx + "   " + dy + "   ");
    //println(dirtohome);
    //println(disttohome);
    //println(offsetangle);

  dirtohome += offsetangle;
  if (dirtohome >  180.0) dirtohome -= 360.0;
  if (dirtohome < -180.0) dirtohome += 360.0;
  
  dirdiff = dirtohome - actdir;
  if (dirdiff >  180.0) dirdiff -= 360.0;
  if (dirdiff < -180.0) dirdiff += 360.0;
  
  if (dirdiff >  30.0) dirdiff =  30.0; // hard limit banking angle
  if (dirdiff < -30.0) dirdiff = -30.0;
  
  actdir += 0.3 * dirdiff;
  
  if (actdir >=  180.0) actdir -= 360.0; 
  if (actdir <= -180.0) actdir += 360.0; 

  stroke (255);
  dirrad = actdir / 57.29;
  newx = oldx + (int)(sin(dirrad) * speed);
  newy = oldy + (int)(cos(dirrad) * speed);
  line(oldx, oldy, newx, newy);
  oldx=newx;
  oldy=newy;

  stroke (10);
  ellipse(homex, homey, 4, 4);
  noFill();
  ellipse(homex, homey, 2*circleradius, 2*circleradius);
}

